#!/usr/bin/env python
# -*- coding: utf-8 -*-
##############   tesseract-gui.py - version 2.8   ##############################
# 
# Copyright 2009 Juan Ramon Castan <juanramoncastan at yahoo.es>
# my_mainwindowd in the previous work of Filip Domenic "guitesseract.py" 
# guitesseract.py
# Copyright 2008 Filip Dominec <filip.dominec at gmail.com>
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.#}}}


import pygtk
pygtk.require('2.0')
import gtk, gobject
import os
import pango
import sys
import subprocess
import threading
import string
import time

gtk.gdk.threads_init()


class MainWindow(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
        # User define variables
        self.Color = (80,30,0) # (red %,green %,blue %)
        self.ContrastValueDefault = 70 # between 0 - 99
        self.RectDefault = None # tuple of values.(x,y,w,h) or None
        self.RotValueDefault = 0 # bteween -180 to 180
        self.IndexActiveDefault = False
        self.TooltipsDefault = True
        self.LanguageDefault = "eng"
        self.Home = os.environ['HOME'] + "/"
        self.DirectoryIn = self.Home

        ###---Window and framework -----------------------------
        self.mainwindow = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.mainwindow.connect("destroy", self.destroy)
        
        self.mainwindow.set_title("Tesseract GUI 2.8")
        self.mainwindow.connect('destroy', lambda w: gtk.main_quit())
        global SHARE_PATH
        self.mainwindow.set_icon_from_file(os.path.join(SHARE_PATH, "tesseract-gui", "tesseract-gui-logo.png"))

        self.f_frontend_lang()

        self.vboxWindow = gtk.VBox(False, 1)
        self.mainwindow.add(self.vboxWindow)
        self.vboxWindow.show()

        self.hboxWindow = gtk.HBox(False, 3)
        self.vboxWindow.pack_start(self.hboxWindow,True, True, 1)
        self.hboxWindow.show()
        #---------------------------------------------------

    ###---Left of Window-------------------------------------
        self.vboxLeft = gtk.VBox(False, 1)
        self.hboxWindow.pack_start(self.vboxLeft, False, True, 2)
        self.vboxLeft.show()
        

        self.headHBox = gtk.HBox(False,1)
        self.vboxLeft.pack_start(self.headHBox, False, False, 1)
        self.headHBox.show()

        self.imgIcon=gtk.Image()
        self.imgIcon.set_from_file(os.path.join(SHARE_PATH, "tesseract-gui", "tesseract-gui-logo.png"))
        self.headHBox.pack_start(self.imgIcon,False,False,1)
        self.imgIcon.show()
        
        self.lblHead=gtk.Label()
        self.lblHead.set_markup("<b>Tesseract-GUI</b>")
        self.headHBox.pack_start(self.lblHead,False,False,1)
        self.lblHead.show()

        #--- Tooltips
        self.frameTooltips = gtk.Frame(None)
        self.vboxLeft.pack_start(self.frameTooltips, False, False, 1)
        self.frameTooltips.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameTooltips.show()

        self.hboxTooltips = gtk.HBox(False, 3)
        self.frameTooltips.add(self.hboxTooltips)
        self.hboxTooltips.show()

        self.chkTooltips = gtk.CheckButton()
        self.chkTooltips.set_active(self.TooltipsDefault)
        self.chkTooltips.set_label(self.LCtooltips)
        self.chkTooltips.set_tooltip_text(self.LCtooltips_tip)
        self.hboxTooltips.pack_start(self.chkTooltips, False, False, 1)
        self.chkTooltips.connect("toggled", self.f_set_tooltips)
        self.chkTooltips.show()


        #--- File Selector
        self.dlgFiles = gtk.FileChooserDialog(self.LCselimg, None,\
                            gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_CANCEL,\
                            gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))

        self.dlgFiles.set_select_multiple(True)
        self.filterFiles = gtk.FileFilter()
        self.filterFiles.add_mime_type("image/png")
        self.filterFiles.add_mime_type("image/tiff")
        self.filterFiles.add_mime_type("image/jpeg")
        self.filterFiles.add_mime_type("image/bmp")
        self.dlgFiles.add_filter(self.filterFiles)
        self.dlgFiles.connect("response", self.f_load_files)

        self.lblSelectfile = gtk.Label()
        self.lblSelectfile.set_markup("<b>"+self.LCselimg+"</b>")
        self.vboxLeft.pack_start(self.lblSelectfile, False, False, 1)
        self.lblSelectfile.show()

        self.btnFiles = gtk.FileChooserButton(self.dlgFiles)
        self.btnFiles.set_tooltip_text(self.LCselimg_tip)

        self.btnFiles.set_width_chars(18)
        self.vboxLeft.pack_start(self.btnFiles, False, False, 1)
        self.btnFiles.show()

        self.lblDirectory = gtk.Label()
        self.lblDirectory.set_markup("<b>"+self.LCoutfolder+"</b>")
        self.vboxLeft.pack_start(self.lblDirectory, False, False, 1)
        self.lblDirectory.show()

        self.dlgDestFolder = gtk.FileChooserDialog(self.LCoutfolder_tip\
                                , None, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER \
                                , (gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL\
                                , gtk.STOCK_OPEN,gtk.RESPONSE_OK))

        self.btnDirectory = gtk.FileChooserButton(self.dlgDestFolder)
        self.btnDirectory.set_current_folder(os.getenv('HOME'))
        self.btnDirectory.connect("current_folder_changed"\
                            , self.f_output_filename,None)
        self.btnDirectory.set_tooltip_text(self.LCoutfolder_tip)
        self.btnDirectory.set_width_chars(10)
        self.vboxLeft.pack_start(self.btnDirectory, False, False, 1)
        self.btnDirectory.show()

        #---Images List
        self.imgList = gtk.ListStore(str)

        self.treeView = gtk.TreeView(self.imgList)
        self.treeView.connect("row-activated", self.f_show_img,None,False)
        self.tvSeleccion = self.treeView.get_selection()
        #self.tvSeleccion.connect("changed", self.f_show_img,None,None,None,True)
        self.tvSeleccion.connect("changed", self.f_select_img)
        self.cell = gtk.CellRendererText()
        self.tvColumn = gtk.TreeViewColumn("", self.cell, text=0)
        self.treeView.append_column(self.tvColumn)
        self.treeView.show()

        self.scrollFiles = gtk.ScrolledWindow()
        self.vboxLeft.pack_start(self.scrollFiles, True, True, 1)
        self.scrollFiles.set_size_request(300,100)
        self.scrollFiles.show()
        self.scrollFiles.add(self.treeView)




#-- OCR -----------------
# Pack-ends
        #--Concatenate--
        self.frameConcaten = gtk.Frame(None)
        self.vboxLeft.pack_end(self.frameConcaten, False, False, 1)
        self.frameConcaten.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameConcaten.show()

        self.vboxConcat = gtk.VBox(False, 3)
        self.frameConcaten.add(self.vboxConcat)
        self.vboxConcat.show()

        self.hboxConcat = gtk.HBox(False, 3)
        self.vboxConcat.pack_start(self.hboxConcat, False, False, 1)
        self.hboxConcat.show()

        self.lblConcattit = gtk.Label()
        self.lblConcattit.set_markup(" <b>"+self.LCconcat+"</b>")
        self.hboxConcat.pack_start(self.lblConcattit, False, False, 1)
        self.lblConcattit.show()

        self.dlgConcat = gtk.FileChooserDialog(self.LCseltxt, None,\
                            gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_CANCEL,\
                            gtk.RESPONSE_CANCEL,self.LCconcat,gtk.RESPONSE_OK))
        self.dlgConcat.set_select_multiple(True)
        self.filterText = gtk.FileFilter()
        self.filterText.add_mime_type("text/plain")
        self.dlgConcat.add_filter(self.filterText)
        self.dlgConcat.connect("response", self.f_concat_files)

        self.btnConcat = gtk.FileChooserButton(self.dlgConcat)
        self.btnConcat.set_tooltip_text(self.LCconcatfiles_tip)
        self.btnConcat.set_current_folder(os.getenv('HOME'))
        self.btnConcat.set_width_chars(18)
        self.vboxConcat.pack_end(self.btnConcat, False, False, 3)
        self.btnConcat.show()



        self.hboxConcat1 = gtk.HBox(False, 3)
        self.vboxConcat.pack_end(self.hboxConcat1, False, False, 1)
        self.hboxConcat1.show()

        self.lblConcatnom = gtk.Label()
        self.lblConcatnom.set_markup(" "+self.LCconcatnom)
        self.hboxConcat1.pack_start(self.lblConcatnom, False, False, 1)
        self.lblConcatnom.show()

        self.edtConcat =  gtk.Entry(20)
        self.edtConcat.set_tooltip_text(self.LCconcatnom_tip)
        self.edtConcat.set_width_chars(9)
        self.edtConcat.set_width_chars(15)
        self.hboxConcat1.pack_start(self.edtConcat, False, False, 1)
        self.edtConcat.show()

        self.lblConcatext = gtk.Label()
        self.lblConcatext.set_markup(" .txt")
        self.hboxConcat1.pack_start(self.lblConcatext, False, False, 1)
        self.lblConcatext.show()

        #--OCR--
        self.frameOcr = gtk.Frame(None)
        self.vboxLeft.pack_end(self.frameOcr, False, False, 1)
        self.frameOcr.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameOcr.show()

        self.vboxOcr = gtk.VBox(False,5)
        self.frameOcr.add(self.vboxOcr)
        self.vboxOcr.show()

        #--Page--

        self.hboxProcess = gtk.HBox(False, 3)
        self.vboxOcr.pack_end(self.hboxProcess)
        self.hboxProcess.show()

        self.btnProcess = gtk.Button(self.LCrun,gtk.STOCK_EXECUTE,False)
        self.btnProcess.set_tooltip_text(self.LCexec_tip)
        self.btnProcess.set_use_stock(True)
        self.btnProcess.connect("clicked", self.f_process_img)
        self.hboxProcess.pack_start(self.btnProcess, True, True, 3)

        self.btnProcess.show()

        self.vboxProcess = gtk.VBox(False,1)
        self.hboxProcess.pack_end(self.vboxProcess,False, False,1)
        self.vboxProcess.show()

        self.rdAllimages = gtk.RadioButton(None,self.LCall,False)
        self.rdAllimages.set_tooltip_text(self.LCselect1_tip)
        self.vboxProcess.pack_start(self.rdAllimages, True, False, 1)
        self.rdAllimages.show()

        self.rdSelectedimages = gtk.RadioButton(self.rdAllimages\
                                ,self.LCselected,False)
        self.rdSelectedimages.set_tooltip_text(self.LCselect2_tip)
        self.vboxProcess.pack_start(self.rdSelectedimages, True, False, 1)
        self.rdSelectedimages.show()

        self.hboxPager = gtk.HBox(False, 3)
        self.vboxOcr.pack_end(self.hboxPager, False, False,1)
        self.hboxPager.hide()

        self.vboxPagePrefix = gtk.VBox(False,1)
        self.hboxPager.pack_start(self.vboxPagePrefix, False, False, 1)
        self.vboxPagePrefix.show()


        self.vboxPagStart = gtk.VBox(False,1)
        self.hboxPager.pack_start(self.vboxPagStart, False, False, 1)
        self.vboxPagStart.show()

        self.vboxPagStep = gtk.VBox(False,1)
        self.hboxPager.pack_start(self.vboxPagStep, False, False, 1)
        self.vboxPagStep.show()

        self.edtPagePrefix =  gtk.Entry(20)
        self.edtPagePrefix.set_width_chars(12)
        self.edtPagePrefix.set_text("page_")
        self.vboxPagePrefix.pack_end(self.edtPagePrefix, False, False, 1)
        self.edtPagePrefix.connect("changed", self.f_output_filename, None)
        self.edtPagePrefix.show()


        self.lblInit = gtk.Label()
        self.lblInit.set_markup(self.LCstart)
        self.vboxPagStart.pack_start(self.lblInit, False, False, 1)
        self.lblInit.show()

        self.edtInitPage =  gtk.SpinButton()
        self.vboxPagStart.pack_start(self.edtInitPage, False, False, 1)
        self.edtInitPage.set_adjustment(gtk.Adjustment(0, 1, 9999, 1, 1))
        self.edtInitPage.set_value(1)
        self.edtInitPage.set_width_chars(4)
        self.edtInitPage.connect("changed", self.f_output_filename, None)
        self.edtInitPage.show()


        self.lblStep = gtk.Label()
        self.lblStep.set_markup(self.LCstep)
        self.vboxPagStep.pack_start(self.lblStep, False, False, 1)
        self.lblStep.show()

        self.edtPageStep =  gtk.SpinButton()
        self.vboxPagStep.pack_start(self.edtPageStep, False, False, 1)
        self.edtPageStep.set_adjustment(gtk.Adjustment(0, 1, 4, 1, 1))
        self.edtPageStep.set_value(1)
        self.edtPageStep.set_width_chars(1)
        self.edtPageStep.connect("changed", self.f_output_filename, None)
        self.edtPageStep.show()


        self.vboxColumn = gtk.VBox(False,1)
        self.hboxPager.pack_start(self.vboxColumn, False, False, 1)
        self.vboxColumn.show()

        self.lblCol = gtk.Label()
        self.lblCol.set_markup(self.LCcolumn)
        self.vboxColumn.pack_start(self.lblCol, False, False, 1)
        self.lblCol.show()

        self.edtCol =  gtk.SpinButton()
        self.vboxColumn.pack_start(self.edtCol, False, False, 1)
        self.edtCol.set_adjustment(gtk.Adjustment(0, 0, 6, 1, 1))
        self.edtCol.set_value(0)
        self.edtCol.set_width_chars(1)
        self.edtCol.connect("changed", self.f_output_filename, None)
        self.edtCol.show()


        self.chkPageNumbering = gtk.CheckButton(self.LCindextext)
        self.chkPageNumbering.set_tooltip_text(self.LCindex_tip)
        self.chkPageNumbering.set_active(self.IndexActiveDefault)
        self.vboxOcr.pack_end(self.chkPageNumbering, False, False, 1)
        self.chkPageNumbering.connect("clicked", self.f_output_filename,None)
        self.chkPageNumbering.show()

        #--Language--
        self.hboxLanguage = gtk.HBox(False, 3)
        self.vboxOcr.pack_end(self.hboxLanguage)
        self.hboxLanguage.show()

        self.cmbLang = gtk.combo_box_new_text()
        self.cmbLang.set_tooltip_text(self.LClanguage_tip)
        self.hboxLanguage.pack_end(self.cmbLang, False, False, 1)
        self.cmbLang.connect("changed" , self.f_lang_choice)
        self.cmbLang.show()

        self.lblLan = gtk.Label()
        self.lblLan.set_tooltip_text(self.LClanguage_tip)
        self.lblLan.set_markup(self.LClanguage)
        self.hboxLanguage.pack_end(self.lblLan, False, False, 1)
        self.lblLan.show()

        self.lblOcr = gtk.Label()
        self.lblOcr.set_markup(" <b>"+self.LCocr+"</b>")
        self.hboxLanguage.pack_start(self.lblOcr, False, False, 1)
        self.lblOcr.show()



        # Rotate
        self.frameRotate = gtk.Frame(None)
        self.vboxLeft.pack_end(self.frameRotate, False, False, 1)
        self.frameRotate.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameRotate.show()

        self.vboxRotate = gtk.VBox(False,5)
        self.frameRotate.add(self.vboxRotate)
        self.vboxRotate.show()

        self.hboxRotButlbl = gtk.HBox(False, 3)
        self.vboxRotate.pack_start(self.hboxRotButlbl, False, False,1)
        self.hboxRotButlbl.show()

        self.lblRotate = gtk.Label()
        self.lblRotate.set_markup(" <b>"+self.LCrotate+"</b> ")
        self.hboxRotButlbl.pack_start(self.lblRotate, False, False,1)
        self.lblRotate.show()

        self.hboxRotBut = gtk.HBox(False, 3)
        self.vboxRotate.pack_start(self.hboxRotBut, False, False,1)
        self.hboxRotBut.show()


        self.edtRotAngle =  gtk.SpinButton()
        self.edtRotAngle.set_tooltip_text(self.LCrot_tip)
        self.hboxRotBut.pack_start(self.edtRotAngle, False, False, 1)
        self.edtRotAngle.set_width_chars(4)
        self.edtRotAngle.set_adjustment(gtk.Adjustment(0, -180, 180, 1, 1))
        self.edtRotAngle.set_text("0")
        self.edtRotAngle.connect("button-press-event",self.f_angle_press)
        self.edtRotAngle.connect("focus-in-event",self.f_angle_press)
        self.edtRotAngle.connect("button-release-event",self.f_angle_value)
        self.edtRotAngle.connect("focus-out-event",self.f_angle_value)
        self.edtRotAngle.connect("activate",self.f_angle_value)
        self.edtRotAngle.show()

        self.btnResRot = gtk.Button(self.LCreset)
        self.btnResRot.set_tooltip_text(self.LCreset_tip)
        self.btnResRot.connect("clicked", self.f_angle_change,None, True)
        self.hboxRotBut.pack_start(self.btnResRot, False, False, 1)
        self.btnResRot.show()

        self.btnRot = gtk.Button(self.LCgeneralize)
        self.btnRot.set_tooltip_text(self.LCgeneralize3_tip)
        self.btnRot.connect("clicked", self.f_generallize,5)
        self.hboxRotBut.pack_end(self.btnRot, False, False, 1)
        self.btnRot.show()

        self.rotateDegrees = gtk.HScrollbar()
        self.rotateDegrees.set_tooltip_text(self.LCrot_tip)
        self.vboxRotate.pack_start(self.rotateDegrees, True, True, 1)
        self.rotateDegrees.show()
        self.rotateDegrees.set_adjustment(gtk.Adjustment\
                        (0 , (-180) , (180)+1 , 1 ,1 , 1))

        self.rotateDegrees.set_value(0)
        self.rotateDegrees.connect("value-changed",self.f_angle_change2)
        self.rotateDegrees.connect("button-release-event" , self.f_angle_value, False)



        # Crop
        self.frameCrop = gtk.Frame(None)
        self.frameCrop.set_tooltip_text(self.LCcrop_tip)
        self.vboxLeft.pack_end(self.frameCrop, False, False, 1)
        self.frameCrop.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameCrop.show()

        self.vboxCrop = gtk.VBox(False,5)
        self.frameCrop.add(self.vboxCrop)
        self.vboxCrop.show()

        self.hboxCroplb = gtk.HBox(False,5)
        self.vboxCrop.pack_start(self.hboxCroplb,False,False,1)
        self.hboxCroplb.show()

        self.lblCrop = gtk.Label()
        self.lblCrop.set_markup(" <b>"+self.LCcrop+"</b>")
        self.hboxCroplb.pack_start(self.lblCrop,False,False,1)
        self.lblCrop.show()

        self.hboxCrop = gtk.HBox(False,5)
        self.vboxCrop.pack_start(self.hboxCrop,False,False,1)
        self.hboxCrop.show()

        self.vboxCropL = gtk.VBox(False,5)
        self.hboxCrop.pack_start(self.vboxCropL,False,False,1)
        self.vboxCropL.show()

        self.hboxCropL = gtk.HBox(False,5)
        self.vboxCropL.pack_start(self.hboxCropL,False,False,1)
        self.hboxCropL.show()

        self.lblCropL = gtk.Label()
        self.lblCropL.set_markup(" "+self.LCleft+": ")
        self.hboxCropL.pack_start(self.lblCropL, False, False, 1)
        self.lblCropL.show()

        self.hboxCropT = gtk.HBox(False,5)
        self.vboxCropL.pack_start(self.hboxCropT,False,False,1)
        self.hboxCropT.show()

        self.lblCropT = gtk.Label()
        self.lblCropT.set_markup(" "+self.LCtop+": ")
        self.hboxCropT.pack_start(self.lblCropT, False, False, 1)
        self.lblCropT.show()

        self.vboxCropC = gtk.VBox(False,5)
        self.hboxCrop.pack_start(self.vboxCropC,True,True,1)
        self.vboxCropC.show()

        self.hboxCropR = gtk.HBox(False,5)
        self.vboxCropC.pack_start(self.hboxCropR,False,False,1)
        self.hboxCropR.show()

        self.lblCropR = gtk.Label()
        self.lblCropR.set_markup(" "+self.LCright+": ")
        self.hboxCropR.pack_start(self.lblCropR, False, False, 1)
        self.lblCropR.show()

        self.hboxCropB = gtk.HBox(False,5)
        self.vboxCropC.pack_start(self.hboxCropB,False,False,1)
        self.hboxCropB.show()

        self.lblCropB = gtk.Label()
        self.lblCropB.set_markup(" "+self.LCbottom+": ")
        self.hboxCropB.pack_start(self.lblCropB, False, False, 1)
        self.lblCropB.show()

        self.vboxCropR = gtk.VBox(False,5)
        self.hboxCrop.pack_end(self.vboxCropR,False,True,1)
        self.vboxCropR.show()

        self.btnCrop = gtk.Button(self.LCgeneralize)
        self.btnCrop.set_tooltip_text(self.LCgeneralize2_tip)
        self.btnCrop.connect("clicked", self.f_generallize,6)
        self.vboxCropR.pack_end(self.btnCrop, False, False, 1)
        self.btnCrop.show()


        # Normalize
        self.frameProc = gtk.Frame(None)
        self.vboxLeft.pack_end(self.frameProc, False, False, 1)
        self.frameProc.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameProc.show()

        self.vboxProc = gtk.VBox(False,5)
        self.frameProc.add(self.vboxProc)
        self.vboxProc.show()

        self.hboxNorm = gtk.HBox(False,5)
        self.vboxProc.pack_start(self.hboxNorm,False,False,1)
        self.hboxNorm.show()

        self.lblNormalize = gtk.Label()
        self.lblNormalize.set_tooltip_text(self.LCnormalize_tip)
        self.lblNormalize.set_markup(" <b>"+self.LCnormalize+"</b> ")
        self.hboxNorm.pack_start(self.lblNormalize, False, False, 1)
        self.lblNormalize.show()

        self.chkNormalize = gtk.CheckButton()
        self.chkNormalize.set_tooltip_text(self.LCnormalize_tip)
        self.chkNormalize.set_active(False)
        self.hboxNorm.pack_start(self.chkNormalize, False, False, 1)
        self.chkNormalize.connect("clicked", self.f_normalize_change)
        self.chkNormalize.connect("pressed", self.f_normalize_press,True)
        self.chkNormalize.connect("released", self.f_normalize_press,False)
        self.chkNormalize.show()

        self.btnNormalize = gtk.Button(self.LCgeneralize)
        self.btnNormalize.set_tooltip_text(self.LCgeneralize1_tip)
        self.btnNormalize.connect("clicked", self.f_generallize,4)
        self.hboxNorm.pack_end(self.btnNormalize, False, False, 1)
        self.btnNormalize.show()

        self.hboxAliasing = gtk.HBox(False,5)
        self.vboxProc.pack_start(self.hboxAliasing,False,False,1)
        self.hboxAliasing.show()

        self.chkAliasing = gtk.CheckButton(self.LCaliasing)
        self.chkAliasing.set_tooltip_text(self.LCaliasing_tip)
        self.chkAliasing.set_active(False)
        self.hboxAliasing.pack_start(self.chkAliasing, False, False, 1)
        self.chkAliasing.connect("clicked", self.f_normalize_change)
        self.chkAliasing.connect("pressed", self.f_normalize_press,True)
        self.chkAliasing.connect("released", self.f_normalize_press,False)
        self.chkAliasing.show()

        self.contrastPercent = gtk.HScrollbar()
        self.contrastPercent.set_tooltip_text(self.LCbright_tip)
        self.vboxProc.pack_start(self.contrastPercent, True, True, 1)
        self.contrastPercent.show()
        self.contrastPercent.set_adjustment(gtk.Adjustment\
                        (0 , (1) , (99)+1 , 1 ,1 , 1))
        self.contrastPercent.set_value(self.ContrastValueDefault)
        self.contrastPercent.connect("button-release-event", self.f_normalize_change)
        self.contrastPercent.connect("value-changed" , self.f_contrast_change)

        self.lblPercent = gtk.Label()
        self.lblPercent.set_markup("")
        self.hboxAliasing.pack_end(self.lblPercent, False, False, 1)
        self.lblPercent.hide()

        # Right of Window ---------------------------------
        self.vboxRight = gtk.VBox(False, 1)
        self.hboxWindow.pack_start(self.vboxRight, True, True, 2)
        self.vboxRight.show()


        # Preview Buttons
        self.framePrevOp = gtk.Frame(None)
        self.vboxRight.pack_start(self.framePrevOp, False, False, 1)
        self.framePrevOp.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.framePrevOp.show()
        
        self.hboxPrevOp = gtk.HBox(False,1)
        self.framePrevOp.add(self.hboxPrevOp)
        self.hboxPrevOp.show()

        self.btnAutoPrev = gtk.ToggleButton("Auto Resize")
        self.hboxPrevOp.pack_start(self.btnAutoPrev, False, False, 1)
        self.btnAutoPrev.connect("clicked", self.f_show_buttons)
        self.btnAutoPrev.set_mode(True)
        self.btnAutoPrev.show()

        self.btnPrevMax = gtk.Button("",gtk.STOCK_ZOOM_FIT,False)
        self.btnPrevMax.connect("clicked", self.f_show_img,None,None,None,False)
        self.hboxPrevOp.pack_start(self.btnPrevMax, False, False, 1)
        self.btnPrevMax.show()

        self.btnPrevPlus = gtk.Button("",gtk.STOCK_ZOOM_IN,False)
        self.btnPrevPlus.connect("clicked", self.f_show_img,None,None,1.1,False)
        self.hboxPrevOp.pack_start(self.btnPrevPlus, False, False, 1)
        self.btnPrevPlus.show()

        self.btnPrevMinus = gtk.Button("",gtk.STOCK_ZOOM_OUT,False)
        self.btnPrevMinus.connect("clicked", self.f_show_img,None,None,0.9,False)
        self.hboxPrevOp.pack_start(self.btnPrevMinus, False, False, 1)
        self.btnPrevMinus.show()


        #---Show Window
        self.scrolledwindow = gtk.ScrolledWindow()
        self.scrolledwindow.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)
        self.vboxRight.pack_start(self.scrolledwindow, True, True, 2)
        self.scrolledwindow.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)
        self.scrolledwindow.show()

        self.drawingArea = gtk.DrawingArea()
        self.drawingArea.set_tooltip_text(self.LCcrop3_tip)
        self.drawingArea.set_size_request(0,0)
        self.drawingArea.set_events(gtk.gdk.EXPOSURE_MASK \
            | gtk.gdk.LEAVE_NOTIFY_MASK | gtk.gdk.BUTTON_PRESS_MASK \
            | gtk.gdk.POINTER_MOTION_MASK | gtk.gdk.POINTER_MOTION_HINT_MASK \
            | gtk.gdk.BUTTON_RELEASE_MASK | gtk.gdk.BUTTON_RELEASE \
            | gtk.gdk.MOTION_NOTIFY )
                                
        self.drawingArea.connect("expose-event",self.f_redraw_area)
        self.drawingArea.connect("button_press_event",self.f_init_rect,1)
        self.drawingArea.connect("button_release_event",self.f_init_rect,0)
        self.drawingArea.connect("motion_notify_event",self.f_draw_rect,1)
        self.scrolledwindow.add_with_viewport(self.drawingArea)
        self.drawingArea.show()

        # Frame Info
        self.frameInfo = gtk.Frame(None)
        self.vboxRight.pack_start(self.frameInfo, False, False, 1)
        self.frameInfo.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.frameInfo.show()

        self.vboxInfo = gtk.VBox(False, 1)
        self.frameInfo.add(self.vboxInfo)
        self.vboxInfo.show()

        self.hboxInfoIn = gtk.HBox(False, 1)
        self.vboxInfo.add(self.hboxInfoIn)
        self.hboxInfoIn.show()

        self.lblInfoIn = gtk.Label()
        self.lblInfoIn.set_markup("<b> "+self.LCimage+": </b>(none)")
        self.hboxInfoIn.pack_start(self.lblInfoIn, False, False, 1)
        self.lblInfoIn.show()

        self.hboxInfoOut = gtk.HBox(False, 1)
        self.vboxInfo.add(self.hboxInfoOut)
        self.hboxInfoOut.show()

        self.lblInfoOut = gtk.Label()
        self.lblInfoOut.set_markup("<b> "+self.LCtextfile+": </b>(none)")
        self.hboxInfoOut.pack_start(self.lblInfoOut, False, False, 1)
        self.lblInfoOut.show()

        # Show the window-------------------------------------------------------
        self.mainwindow.show()
        self.dlgFiles.set_current_folder(os.environ['HOME']+"/")
        self.f_init_variables()
        self.f_create_lang()
        self.f_reset_widgets(False)
    # __init__ END

################################################################################
### Functions-------------------------------------------------------------------
    ### Importatnt Functions ---------------------------------------------------

    def f_init_variables(self):
        print "reseting variables..."
        self.imgList.clear()
        self.Scale=None
        self.Images=[]
        self.ImageWidth=None
        self.ImageHeight=None
        self.Selected=None
        self.pixBuf=None
        self.pixBufPrev=None
        self.Pressed=None
        self.rectangle=None
        self.ConfFile = ".tesseract-guirc"
        self.dialogPrev = None
        self.dialogInfo = None
        self.dialogError = None
        self.AnglePress = None

        self.f_read_conf()

        self.DibujaArea=0
        self.Pressed=0
        self.PgStt=1
        self.PgStp=1
        self.PgClm=0
        self.ColorMath=int(65535/100)
        self.drawingArea.window.clear()
    #}} f_init_variables END


    def f_reset_widgets(self,data):

        self.ActiveWidgets = data
        self.chkPageNumbering.set_active(self.IndexActiveDefault)
        self.rotateDegrees.set_value(self.RotValueDefault)
        self.contrastPercent.set_value(self.ContrastValueDefault)
        self.chkNormalize.set_active(False)
        self.chkAliasing.set_active(False)
        self.contrastPercent.set_sensitive(False)
        self.edtConcat.set_text(self.LCfinaltext)

        self.btnDirectory.set_sensitive(data)
        self.scrollFiles.set_sensitive(data)
        self.frameConcaten.set_sensitive(data)
        self.frameOcr.set_sensitive(data)
        self.frameRotate.set_sensitive(data)
        self.frameCrop.set_sensitive(data)
        self.frameProc.set_sensitive(data)
        self.vboxRight.set_sensitive(data)

    # f_reset_widgets END


    def f_load_files(self, widget, data):
        if data == -5 :
            self.f_init_variables()
            self.DirectoryIn = self.dlgFiles.get_current_folder() + "/"
            self.FolderOut= self.DirectoryIn 
            self.tvColumn.set_title(self.DirectoryIn)
            self.Files=self.dlgFiles.get_filenames()
            self.btnConcat.set_current_folder(self.FolderOut)
            if self.Files :
                self.f_reset_widgets(False)
                self.treeView.set_tooltip_text(self.LCscrollimg_tip)
                print "\nLoading images from: " + self.DirectoryIn
                nnfin = len(self.Files)
                for nn in range(0,nnfin) :
                    File = self.Files[nn]
                    (Path,Image) = File.rsplit("/",1)
                    (Name,Ext) = Image.rsplit(".",1)
                    Ext = "." + Ext
                    self.imgList.append([Image])
                    #### ---- Images is a list:
                    # ------- 0=Index
                    # ------- 1=Image
                    # ------- 2=Name
                    # ------- 3=Extension
                    # ------- 4=Normalize
                    # ------- 5=Rotate
                    # ------- (6=Rectangles)[n]
                    # ------- 7=Denoise
                    if self.chkNormalize.get_active() == True :
                        Norm = int(self.contrastPercent.get_value())
                    else :
                        Norm = 0
                    Rot = self.RotValueDefault
                    if self.RectDefault:
                        Rect = gtk.gdk.Rectangle(self.RectDefault[0],self.RectDefault[1],self.RectDefault[2],self.RectDefault[3])
                    else :
                        Rect = None
                    Denoise = False
                    Norm = False

                    self.Images.append([nn,Image,Name,Ext,Norm,Rot,[Rect],Denoise])
                    print " " + Image
                self.btnDirectory.set_sensitive(True)
                self.scrollFiles.set_sensitive(True)
                self.f_output_filename(None,None)
            else:
                self.treeView.set_tooltip_text("")
        self.btnFiles.set_current_folder(self.DirectoryIn)
        self.btnDirectory.set_current_folder(self.DirectoryIn)
    #}} f_load_files END


    def f_show_img(self,widget,data,data2,Zoom,WritePrev):
        #----- Image = (self.Images[self.Selected])[1]
        #----- Name = (self.Images[self.Selected])[2]
        #----- Ext = (self.Images[self.Selected])[3]
        #----- Norm = (self.Images[self.Selected])[4]
        #----- Rotate = (self.Images[self.Selected])[5]
        #----- Rect = (self.Images[self.Selected])[6]
        #----- Denoise = (self.Images[self.Selected])[7]

        self.ScrolledWidth = self.scrolledwindow.allocation.width - 30
        if self.Selected != None:
            self.drawingArea.set_tooltip_text(self.LCcrop2_tip)
            self.f_output_filename(None,self.Selected)
            Index = (self.Images[self.Selected])[0]
            Image = (self.Images[self.Selected])[1]
            Name = (self.Images[self.Selected])[2]
            Ext = (self.Images[self.Selected])[3]
            Norm = (self.Images[self.Selected])[4]
            Rotate = (self.Images[self.Selected])[5]
            Rect = (self.Images[self.Selected])[6]
            Denoise = (self.Images[self.Selected])[7]
            if Norm != False:
                self.chkNormalize.set_active(True)
                self.contrastPercent.set_value(int(Norm))
                self.contrastPercent.set_sensitive(True)
                self.lblPercent.show()
            else:
                self.chkNormalize.set_active(False)
                self.contrastPercent.set_sensitive(False)
                self.lblPercent.hide()
            self.chkAliasing.set_active(Denoise)
            self.rotateDegrees.set_value(float(Rotate))
            self.rectangle = Rect[0]
            self.Interp = gtk.gdk.INTERP_NEAREST
            if WritePrev == True:
                if self.dialogPrev :
                    self.dialogPrev.change(self.LCprevtit,self.LCprevtext)
                else:
                    self.dialogPrev = Dialogo("info",self.LCprevtit,self.LCprevtext,"hide")
                self.ShowThread = threading.Thread(target=self.f_show_idle , args=(Index,Image,Zoom)).start()
            else:
                if Zoom and self.Scale:
                    self.Scale = self.Scale * Zoom
                else:
                    self.Scale = (float(self.ScrolledWidth) / float(self.ImageW))
                self.drawingArea.set_size_request(int(self.ImageW * self.Scale),int(self.ImageH * self.Scale))
                self.pixBufPrev = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB,False,8,int(self.ImageW*self.Scale),int(self.ImageH*self.Scale))
                self.pixBuf.scale(self.pixBufPrev,0,0,int(self.ImageW * self.Scale),int(self.ImageH * self.Scale),0,0,self.Scale,self.Scale,self.Interp)
                self.f_redraw_area(self,None)
    #}} f_show_img END

    def f_show_idle(self,Index,Image,Zoom):
        gobject.idle_add(self.f_show_thread,Index,Image,Zoom)

    def f_show_thread(self,Index,Image,Zoom):
        print self.LCprevtext
        gtk.gdk.threads_enter()
        self.drawingArea.window.clear()
        general_option = "-quality 70"
        rotate_option = " " + self.f_opRotate(Index)
        normalize_option = " "  + self.f_opNormalize(Index)
        options= general_option + rotate_option + normalize_option
        runBash("convert '" + self.DirectoryIn + Image  + "' " + options + " '/tmp/tesseract_preview.jpg'")
        self.pixBuf=gtk.gdk.pixbuf_new_from_file("/tmp/tesseract_preview.jpg")
        self.ImageW = self.pixBuf.get_width()
        self.ImageH = self.pixBuf.get_height()
        if Zoom and self.Scale:
            self.Scale = self.Scale * Zoom
        else:
            self.Scale = (float(self.ScrolledWidth) / float(self.ImageW))
        self.drawingArea.set_size_request(int(self.ImageW * self.Scale),int(self.ImageH * self.Scale))
        self.pixBufPrev = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB,False,8,int(self.ImageW*self.Scale),int(self.ImageH*self.Scale))
        self.pixBuf.scale(self.pixBufPrev,0,0,int(self.ImageW * self.Scale),int(self.ImageH * self.Scale),0,0,self.Scale,self.Scale,self.Interp)
        self.f_redraw_area(self,None)
        if self.dialogPrev :
            self.dialogPrev.destroy(None,"ok")
            self.dialogPrev = None
        gtk.gdk.threads_leave()
        #return False


    def f_redraw_area(self, widget, event):
        gc = self.drawingArea.get_style().fg_gc[gtk.STATE_NORMAL]
        colormap = self.drawingArea.get_colormap()
        color = colormap.alloc_color(int(self.ColorMath * self.Color[0]) \
                ,int(self.ColorMath * self.Color[1]),int(self.ColorMath * self.Color[2]),False,False)
 
        gcArea = self.drawingArea.window.new_gc()
        gcArea.set_foreground(color)
        gcArea.set_dashes(15, (6,6))
        gcArea.line_width = 2
        gcArea.line_style = gtk.gdk.LINE_ON_OFF_DASH
        gcHand = self.drawingArea.window.new_gc()
        gcHand.set_foreground(color)
        gcHand.line_width = 3
        gcHand.line_style = gtk.gdk.SOLID
        gcHand.fill = gtk.gdk.SOLID
        self.ScrolledWidth =  self.scrolledwindow.allocation.width - 30
        Scale = self.Scale
        if self.pixBufPrev:

            if self.btnAutoPrev.get_active() == True:
                Scale = (float(self.ScrolledWidth) / float(self.ImageW))
                self.pixBufPrev = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB,False,8\
                                ,int(self.ImageW*Scale),int(self.ImageH*Scale))

                self.pixBuf.scale(self.pixBufPrev,0,0,int(self.ImageW*Scale)\
                            ,int(self.ImageH*Scale),0,0,Scale,Scale,self.Interp)

                self.drawingArea.set_size_request(int(self.ImageW * Scale)\
                            ,int(self.ImageH * Scale))

            self.drawingArea.window.draw_pixbuf(gc, self.pixBufPrev, 0, 0, 0, 0)

            if self.rectangle :
                x = self.rectangle.x
                y = self.rectangle.y
                xx = (self.rectangle.x + self.rectangle.width)
                yy = (self.rectangle.y + self.rectangle.height)
                w = self.rectangle.width
                h = self.rectangle.height
                rectx = int(x * Scale)
                recty = int(y * Scale)
                rectxx = int((x + w) * Scale)
                rectyy = int((y + h) * Scale)
                rectw = int(w * Scale)
                recth = int(h * Scale)

                self.drawingArea.window.draw_rectangle( gcArea , False \
                                , rectx , recty , rectw , recth)

                self.drawingArea.window.draw_rectangle( gcHand , False \
                                , (rectx + 5) , (recty + 5 ) , 10 ,10)

                self.drawingArea.window.draw_rectangle( gcHand , False \
                                , (rectxx-7) , ( rectyy-7) , 5 , 5 )
            else:
                x = ""
                y = ""
                xx = ""
                yy = ""
            self.lblCropL.set_markup(" "+self.LCleft+": " + str(x))
            self.lblCropR.set_markup(" "+self.LCright+": " + str(xx))
            self.lblCropT.set_markup(" "+self.LCtop+": " + str(y))
            self.lblCropB.set_markup(" "+self.LCbottom+": " + str(yy))
            self.Scale = Scale
    #}} f_redraw_area END


    def f_process_img(self,widget):
        Comprueba = ""
        self.ToProc = ""
        self.ImagesToProcess=[]
        if self.rdAllimages.get_active() :
            if len(self.Images) > 0: self.ImagesToProcess = self.Images
        elif self.rdSelectedimages.get_active() :
            if self.Selected != None : self.ImagesToProcess.append(\
                            self.Images[self.Selected])
        nnfin = len(self.ImagesToProcess)
        if nnfin:
            print "\nTesseract Open Source OCR Engine"
            print "Language: " + lang
            self.aa = 1
            for ee in range (0,nnfin):
                Index = (self.ImagesToProcess[ee])[0]
                Image = (self.ImagesToProcess[ee])[1]
                self.ToProc = self.ToProc +"\n"+ Image
                NameOut = self.f_output_filename(None,Index)
                Comp = ""
                Comp = runBash("ls '"+self.FolderOut+NameOut+".txt' 2> /dev/null")
                if Comp :
                    Comprueba = Comprueba+"\n"+self.FolderOut+NameOut+".txt"
            if Comprueba:
                print self.LCabort1+Comprueba
                self.dialogError = Dialogo("files",self.LCabort,self.LCabort1+Comprueba+"\n"+self.LCabort2,"show",True)
            else:
                self.f_process_continue()
    # f_process_img END


    def f_process_continue(self):
        self.dialogInfo = Dialogo("info",self.LCrun,self.LCprocess+":\n"+self.ToProc,"show",True)
        self.ProcessThread = threading.Thread(target=self.f_process_idle , args=()).start()


    def f_process_idle(self):
        gobject.idle_add(self.f_process_thread)
    # f_process_idle END


    def f_process_thread(self):
        gtk.gdk.threads_enter()
        nnfin = len(self.ImagesToProcess)
        self.aa = 1
        for nn in range (0,nnfin):
            Index = (self.ImagesToProcess[nn])[0]
            Image = (self.ImagesToProcess[nn])[1]
            Name = (self.ImagesToProcess[nn])[2]
            Ext = (self.ImagesToProcess[nn])[3]
            Norm = (self.ImagesToProcess[nn])[4]
            Rotate = (self.ImagesToProcess[nn])[5]
            Rect = (self.ImagesToProcess[nn])[6]
            NameOut = self.f_output_filename(None,Index)
            FileIn = self.DirectoryIn + Image
            normalize_option = " " + self.f_opNormalize(Index)
            rotate_option = " " + self.f_opRotate(Index)
            crop_option = " " + self.f_opCrop(Index)
            options = rotate_option + normalize_option + crop_option
            Processtif = "/tmp/tesseract_process"+str(nn)+".tif"
            Processjpg = "/tmp/tesseract_process"+str(nn)+".jpg"
            runBash("convert -compress None -quality 100 '"+FileIn+"' '"+Processjpg+"' ;" )
            runBash("mogrify -compress None "+options+" '"+Processjpg+"' ;" )
            runBash("convert -compress None -depth 8 '"+Processjpg+"'  '"+Processtif+"' ;" )
            runBash("rm '" + Processjpg  + "' ;")
            runBash("tesseract '"+Processtif+"' '"+self.FolderOut+NameOut+"' -l "+lang+" ;")
            print "Recognition: "+self.FolderOut+NameOut+".txt"
            runBash("rm '" + Processtif  + "' ;")
            self.aa = self.aa+1
        self.dialogInfo.change(self.LCrun,self.LCprocessend)
        print self.LCprocessend
        gtk.gdk.threads_leave()

    # f_process_thread END
        
        
### Secondary Functions-----------------------------------------------------

    def f_select_img(self,widget):
        if self.tvSeleccion.get_selected_rows()[1] != []:
            Sel = self.tvSeleccion.get_selected_rows()[1]
            Selected = ((self.tvSeleccion.get_selected_rows()[1])[0])[0]
            self.Selected = Selected
            if self.ActiveWidgets == False:
                self.f_reset_widgets(True)
            self.f_show_img(None,None,None,1,True)
            return Selected
    #}} f_select_img END

    def f_output_filename(self,widget,Index):
        self.f_destination_folder(self,None)
        NameIn = self.LCnameoffile
        NameOut = self.LCnameoffile

        if self.Images:
            if Index == None : 
                Index = self.Selected
            if self.chkPageNumbering.get_active() == True:
                self.hboxPager.show()
                if Index != None and self.edtInitPage.get_text() != '': 

                    if int(self.edtCol.get_text()) == 0:
                        Column = ""
                    elif int(self.edtCol.get_text()) != 0 or self.edtCol.get_text() != None:
                        Column = "-col_" + self.edtCol.get_text()

                    Page = (int(self.edtInitPage.get_text()) \
                                + (int(self.edtPageStep.get_text() )*Index ))

                    NameOut = (self.edtPagePrefix.get_text() + str( Page ) + str(Column))
                    NameIn = (self.Images[Index])[1] 
                else:
                    NameOut = self.edtPagePrefix.get_text() + "(index)"
            else:
                self.hboxPager.hide()
                if Index != None :
                    NameIn = (self.Images[Index])[1]
                    NameOut = (self.Images[Index])[2]

            self.lblInfoIn.set_markup("<b> "+self.LCimage+":</b> " + self.DirectoryIn + NameIn)
            self.lblInfoOut.set_markup("<b> "+self.LCtextfile+":</b> " \
                                    + self.FolderOut  + NameOut + ".txt") 
            return NameOut
        else:
            self.chkPageNumbering.set_active(False)
    #}} f_output_filename END


    def f_destination_folder(self,widget,data):
        self.FolderOut = self.btnDirectory.get_current_folder() + "/"
        self.btnConcat.set_current_folder(self.FolderOut)
        return self.FolderOut        
    #}} f_destination_folder END


    def f_show_buttons(self,widget):
        if self.btnAutoPrev.get_active() == True:
            self.btnPrevMinus.hide()
            self.btnPrevMax.hide()
            self.btnPrevPlus.hide()
            self.f_show_img(None,None,None,None,False)
        if self.btnAutoPrev.get_active() == False:
            self.btnPrevMinus.show()
            self.btnPrevMax.show()
            self.btnPrevPlus.show()
            self.f_show_img(None,None,None,None,False)
    #}} f_show_buttons END


    def f_angle_change(self , widget,Dato, Reset):
        if Reset:
            self.rotateDegrees.set_value(0)
        angle = (int (self.rotateDegrees.get_value()) )
        self.f_angle_change2(None)
        if self.Selected != None:
            (self.Images[self.Selected])[5] = angle
        self.f_show_img(None,None,None,1,True)
    # f_angle_change END


    def f_angle_change2(self,widget):
        self.edtRotAngle.set_text(str(int(self.rotateDegrees.get_value())))
    # f_angle_change2 END


    def f_angle_press(self,widget,Data):
        self.AnglePress=int(self.edtRotAngle.get_text())
    # f_angle_press END


    def f_angle_value(self,widget,Data=None,otro=None):
        if self.AnglePress != int(self.edtRotAngle.get_text()):
            self.rotateDegrees.set_value(int(self.edtRotAngle.get_text()))
            self.AnglePress = int(self.edtRotAngle.get_text())
            self.f_angle_change(None,None,False)
    # f_angle_change2 END


    def f_normalize_press(self,widget,data):
        self.CheckPressed = data
    # f_normalize_press END


    def f_normalize_change(self,widget,data=None):
        if self.Selected != None :
            if self.chkNormalize.get_active() == True:
                self.contrastPercent.set_sensitive(True)
                self.lblPercent.show()
                (self.Images[self.Selected])[4] = int(self.contrastPercent.get_value())
            else:
                self.contrastPercent.set_sensitive(False)
                self.lblPercent.hide()
                (self.Images[self.Selected])[4] = False
            (self.Images[self.Selected])[7] = self.chkAliasing.get_active()
        else:
            self.chkAliasing.set_active(False)
            self.chkNormalize.set_active(False)
        if self.CheckPressed == True or data:
            self.f_show_img(None,None,None,1,True)
    # f_normalize_change END


    def f_contrast_change(self,widget):
        self.lblPercent.set_markup(""+str(int(self.contrastPercent.get_value()))+" ")
    # f_normalize_press END


    def f_init_rect(self,widget,dato, Evento):
        self.x=None
        self.y=None
        Pressx , Pressy , Nada= self.drawingArea.window.get_pointer()
        self.AreaAction="resize"
        self.Pressed = Evento
        if self.Selected != None:
            if Pressx < (self.ImageW * self.Scale)  and Pressy < (self.ImageH * self.Scale) :
                self.DibujaArea=1
            else:
                self.DibujaArea=0

            if self.Pressed == 1 and self.DibujaArea == 1:
                self.Pressx = Pressx
                self.Pressy = Pressy
                self.rectangle = ((self.Images[self.Selected])[6])[0]
                if self.rectangle :
                    self.Pressx=None
                    self.Pressy=None
                    self.x = int((self.rectangle.x) * self.Scale)
                    self.y = int((self.rectangle.y)* self.Scale)
                    self.xx = int((self.rectangle.x + self.rectangle.width) * self.Scale)
                    self.yy = int((self.rectangle.y + self.rectangle.height) * self.Scale)
                    if Pressx < (self.xx) and Pressy < (self.yy) and Pressx > (self.x) and Pressy > (self.y) :
                        self.drawingArea.window.set_cursor(\
                                    gtk.gdk.Cursor(gtk.gdk.FLEUR))
                        if self.chkTooltips.get_active() == True :
                            self.drawingArea.set_tooltip_text(self.LCcrop2_tip)
                        self.AreaAction = "move"
                        self.Pressx = Pressx
                        self.Pressy = Pressy
                    if Pressx > (self.x + 6) and Pressy > (self.y + 6)  and \
                            Pressx < (self.x  + 16) and Pressy < (self.y + 16) :
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.X_CURSOR))
                        if self.chkTooltips.get_active() == True :
                            self.drawingArea.set_tooltip_text(self.LCcrop6_tip)
                        self.AreaAction="clear"
                        self.Pressx=None
                        self.Pressy=None
                        self.rectangle=None
                        ((self.Images[self.Selected])[6])[0] = None
                        self.f_redraw_area(self,None)
                    if Pressx < (self.xx) and Pressy < (self.yy) and \
                            Pressx > (self.xx - 7) and Pressy > (self.yy - 7) :
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.BOTTOM_RIGHT_CORNER))
                        self.AreaAction = "resize"
                        self.Rectx = self.x
                        self.Recty = self.y
        if self.Pressed == 0:
            self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.ARROW))
            self.drawingArea.set_tooltip_text(self.LCcrop3_tip)
        self.f_show_img(None,None,None,1,False)
    # f_init_rect END


    def f_draw_rect(self,widget,dato, evento):
        if self.chkTooltips.get_active() == False:
            self.drawingArea.set_tooltip_text(self.LCcrop3_tip)
        elif self.chkTooltips.get_active() == True:
            self.drawingArea.set_tooltip_text(self.LCcrop2_tip)
        if self.Selected != None:
            Movex , Movey , Nada= self.drawingArea.window.get_pointer()
            self.rectangle = ((self.Images[self.Selected])[6])[0]
            if self.Pressed == 0 :
                if self.rectangle:
                    x = int((self.rectangle.x) * self.Scale)
                    y = int((self.rectangle.y)* self.Scale)
                    xx = int((self.rectangle.x + self.rectangle.width) * self.Scale)
                    yy = int((self.rectangle.y + self.rectangle.height) * self.Scale)
                    self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.ARROW))
                    self.drawingArea.set_tooltip_text(self.LCcrop3_tip)
                    if Movex < (xx) and Movey < (yy) and Movex > (x) and Movey > (y):
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.HAND1))
                        if self.chkTooltips.get_active() == True :
                            self.drawingArea.set_tooltip_text(self.LCcrop4_tip)
                    if Movex > (x + 6) and Movey > (y + 6)  and Movex < (x  + 16) and Movey < (y + 16):
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.X_CURSOR))
                        if self.chkTooltips.get_active() == True :
                            self.drawingArea.set_tooltip_text(self.LCcrop6_tip)
                    if Movex < (xx) and Movey < (yy) and Movex > (xx - 7) and Movey > (yy - 7):
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.HAND2))
                        if self.chkTooltips.get_active() == True :
                            self.drawingArea.set_tooltip_text(self.LCcrop5_tip)
                else:
                    if Movex < int(self.ImageW * self.Scale) and Movex > 0 and Movey < int(self.ImageH * self.Scale) and Movey > 0:
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.DRAPED_BOX))
                    else: 
                        self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.ARROW))
                        self.drawingArea.set_tooltip_text(self.LCcrop3_tip)

            if self.Pressed == 1 and self.DibujaArea == 1:
                if self.Pressx and self.Pressy :
                    if self.x == None : self.x = self.Pressx
                    if self.y == None : self.y = self.Pressy
                    if self.rectangle:
                        x = int((self.rectangle.x) * self.Scale)
                        y = int((self.rectangle.y)* self.Scale)
                        xx = int((self.rectangle.x + self.rectangle.width) * self.Scale)
                        yy = int((self.rectangle.y + self.rectangle.height) * self.Scale)
                        if self.AreaAction == "resize":
                            self.Rectxx = xx - (xx - Movex) 
                            self.Rectyy = yy - (yy - Movey)
                            if Movex < self.x :
                                self.Rectxx = self.x
                                self.Rectx = Movex
                            if Movey < self.y :
                                self.Rectyy = self.y
                                self.Recty =  Movey
                        elif self.AreaAction == "move":
                            if self.x + (Movex - self.Pressx) > 0:
                                self.Rectx = self.x + (Movex - self.Pressx)
                            else:
                                self.Rect = 0
                            if self.y + (Movey - self.Pressy) > 0:
                                self.Recty = self.y + (Movey - self.Pressy)
                            else:
                                self.Recty = 0
                            if int((self.xx + (Movex - self.Pressx)) / self.Scale) < self.ImageW:
                                self.Rectxx = self.xx + (Movex - self.Pressx)
                            else:
                                self.Rectxx = int(self.ImageW  * self.Scale)
                            if int((self.yy + (Movey - self.Pressy)) / self.Scale) < self.ImageH:
                                self.Rectyy = self.yy + (Movey - self.Pressy)
                            else:
                                self.Rectyy = int(self.ImageH  * self.Scale)
                            if self.Rectx  > int(self.ImageW * self.Scale) - 20:
                                self.Rectx = 1
                            if self.Recty  > int(self.ImageH * self.Scale) -20:
                                self.Recty = 1
                            if self.Rectxx <= 1:
                                self.drawingArea.window.clear()
                                self.Rectxx = int(self.ImageW * self.Scale) -8
                            if self.Rectyy <= 1:
                                self.drawingArea.window.clear()
                                self.Rectyy = int(self.ImageH * self.Scale) -8
                    else:
                        self.Rectx = self.Pressx
                        self.Recty = self.Pressy
                        self.Rectxx = Movex
                        self.Rectyy = Movey
   
                    cropx = int(self.Rectx / self.Scale)
                    cropy = int(self.Recty  / self.Scale)
                    cropxx = int(self.Rectxx  / self.Scale)
                    cropyy = int(self.Rectyy  / self.Scale)
                    if cropx < 0 : cropx = 0
                    if cropy < 0 : cropy = 0
                    if cropxx > self.ImageW : cropxx = self.ImageW
                    if cropyy > self.ImageH : cropyy = self.ImageH
                    cropw = cropxx - cropx
                    croph = cropyy - cropy
                    self.rectangle = gtk.gdk.Rectangle(cropx,cropy,cropw,croph)
                    ((self.Images[self.Selected])[6])[0] = self.rectangle
                    self.f_redraw_area(self,None)
        else:
            self.drawingArea.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.ARROW))
            self.drawingArea.set_tooltip_text(self.LCcrop3_tip)
    # f_draw_rect END


    def f_generallize(self,widget,Nn):
        if self.Selected != None:
            nnfin = len(self.Images)
            for nn in range(0,nnfin):
                if Nn == 6 :
                    ((self.Images[nn])[Nn])[0]=((self.Images[self.Selected])[Nn])[0]
                elif Nn == 4 :
                    (self.Images[nn])[4] = (self.Images[self.Selected])[4]
                    (self.Images[nn])[7] = (self.Images[self.Selected])[7]
                else:
                    (self.Images[nn])[Nn] = (self.Images[self.Selected])[Nn]
            self.f_show_img(None,None,None,1,False)
    # f_generallize END

    def f_create_lang(self):
        Languages = { self.LCspsanish:"spa",\
                    self.LCportuguese:"por",\
                    self.LCitalian:"ita",\
                    self.LCdutch:"nld",\
                    self.LCgerman:"deu",\
                    self.LCfrench:"fra",\
                    self.LCrussian:"rus",\
                    self.LCpolish:"pol",\
                    self.LCenglish:"eng"}
        self.ListLanguages={}
        nnfin=len(Languages)
        Nn=0
        global TESSDATA_PATH
        for lang in Languages.keys():
            #print Languages[lang]
            #print os.path.join(TESSDATA_PATH, Languages[lang] + ".lm")
            if os.path.isfile(os.path.join(TESSDATA_PATH, Languages[lang] + ".traineddata")):

                self.ListLanguages[lang] = Languages[lang]
                self.cmbLang.append_text(lang)
                if self.ConfVars["Language"] == Languages[lang]:
                    self.cmbLang.set_active(Nn)
                Nn = Nn + 1
    # f_create_lang END


    def f_lang_choice(self , widget): 
        global lang
        model = self.cmbLang.get_model()
        active = self.cmbLang.get_active()
        if active < 0:
            return None
        lang = self.ListLanguages[(model[active][0])]
        self.ConfVars["Language"]= lang + "\n"
        self.f_write_conf()
    # f_lang_coice END


    def f_read_conf(self):
        self.ConfVars={}
        try :
            Conff = open(self.Home+self.ConfFile, "r")
            lineas = Conff.readlines()
            nnfin = len(lineas)
            for nn in range(0,nnfin):
                if lineas[nn] == "\n": lineas[nn] = None
                if lineas[nn] :
                    linea = lineas[nn].rstrip("\n")
                    (Key,Value) = linea.split("=",1)
                    self.ConfVars[Key] = Value
                nn = nn+1
            Conff.close() 
        except IOError:
            nn = 0
            self.ConfVars = {"Language":self.LanguageDefault}
            self.f_write_conf()
        if "Language" not in self.ConfVars :
            self.ConfVars["Language"] = self.LanguageDefault
    # f_read_conf END


    def f_write_conf(self):
        Conff = open(self.Home+self.ConfFile, "w")
        nnfin = len(self.ConfVars)
        for nn in range(0,nnfin):
            Par =  self.ConfVars.keys()[nn]+"="+self.ConfVars.values()[nn]
            Conff.write(Par+"\n")
            nn = nn+1
        Conff.close()
    # f_write_conf END


    ### Process Options -------------------------
    def f_opRotate(self,Nn):
        rotate_option = ""
        if (self.Images[Nn])[5] != 0: 
            rotate_option = "-rotate " + str((self.Images[Nn])[5])
        return rotate_option
    # f_opRotate END


    def f_opNormalize(self,Nn):
        if  (self.Images[Nn])[7] == True:
            normalize_option = "-scale 200%x200%  -gaussian 1 -scale 50%x50%"
            if (self.Images[Nn])[4] != False:
                normalize_option = normalize_option + " "
        else:
            normalize_option = ""
        if (self.Images[Nn])[4] != False: 
            contrast = (self.Images[Nn])[4]
            self.contrastPercent.set_value(contrast)
            normalize_option = normalize_option + "-level " + str(contrast) +"%," + str(contrast) +"% -monochrome"
        return normalize_option
    # f_opNormalize END


    def f_opCrop(self,Nn):
        crop_option = ""
        if ((self.Images[Nn])[6])[0]:
            rectangle = (((self.Images[Nn])[6])[0])
            x = str(rectangle.x)
            y = str(rectangle.y)
            w = str(rectangle.width)
            h = str(rectangle.height)
            crop_option = "-crop " + w + "x" + h + "+" + x + "+" + y
        return crop_option
    # f_crop_option END


    def f_concat_files(self, widget, data):

        ConcatFiles=self.dlgConcat.get_filenames()
        Nombre = self.edtConcat.get_text()
        Files = ""
        Folder = self.dlgConcat.get_current_folder()

        if Nombre == "" :
            Nombre = "final_text"
        if ConcatFiles and data == -5:
            Action = "cat "
            nnfin = len(ConcatFiles)
            for nn in range(0,nnfin) :
                File = ConcatFiles[nn]
                Files = Files +" "+ File
            Action = Action + " " + Files
            runBash(Action + " > " + Folder + "/" + Nombre + ".txt;")
    # f_concat_files END


    def f_frontend_lang(self):
        LFE = os.environ['LANG']
        if LFE.count(".") > 0:
            (LanCount,Codif) = LFE.rsplit(".",1)
        else:
            LanCount = LFE
        if LanCount.count("_") > 0:
            (Lang,Country) = LanCount.rsplit("_",1)
        else:
            Lang = LanCount
        if Lang == "es":
            self.LCtooltips = "Mensajes de ayuda"
            self.LCselimg = "Seleccionar imágenes"
            self.LCoutfolder = "Directorio de destino"

            self.LCgeneralize = "Generalizar"
            self.LCnormalize = "Contrastar"
            self.LCaliasing = "Antiruido"
            self.LCcrop = "Cortar"

            self.LCleft = "Izq."
            self.LCright = "Der."
            self.LCtop = "Arriba"
            self.LCbottom = "Abajo"

            self.LCrotate = "Rotación"
            self.LCreset = "Reajustar 0º"

            self.LCocr = "OCR"
            self.LClanguage = "Idioma"

            self.LCindextext = "Indexado automático"
            self.LCstart = "Inicio"
            self.LCstep = "Salto"
            self.LCcolumn = "Columna"
            self.LCall = "Todas"
            self.LCselected = "Actual"

            self.LCimage = "Archivo imagen"
            self.LCtextfile = "Archivo texto"

            self.LCrun = "Procesar"
            self.LCprocess = "Procesando"
            self.LCprocessend = "Reconocimiento de texto finalizado!"

            self.LCprevtit = "Previsualizar"
            self.LCprevtext = "Proceso de previsualización"

            self.LCnameoffile = "nombre_del_archivo"

            self.LCabort = "Aviso!"
            self.LCabort1 = "Atencion!!.\nLos siguientes archivos ya existen:\n "
            self.LCabort2 = "\n¿Seguro que quieres sobreescribirlos?"

            self.LCconcat = "Concatenar"
            self.LCseltxt = "Seleccionar archivos de texto"
            self.LCconcatnom = "Nombre de archivo"
            self.LCfinaltext = "texto_final"

            self.LCspsanish = "Español"
            self.LCenglish = "Inglés"
            self.LCdutch = "Holandés"
            self.LCgerman = "Alemán"
            self.LCfrench = "Francés"
            self.LCitalian = "Italiano"
            self.LCportuguese = "Portugués"
            self.LCrussian = "Ruso"
            self.LCpolish = "Polaco"
            #--- tips spanish
            self.LCtooltips_tip = "Mostrar o esconder mensajes de ayuda"
            self.LCselimg_tip = "Seleccionar las imágenes a convertir en texto"
            self.LCoutfolder_tip = "Seleccionar una carpeta de destino"
            self.LCscrollimg_tip = "Seleccionar la imagen a visualizar"
            self.LCgeneralize1_tip = "Aplicar o eliminar contraste\na todas las imágenes"
            self.LCgeneralize2_tip = "Aplicar o eliminar recorte\na todas las imágenes"
            self.LCgeneralize3_tip = "Aplicar o eliminar rotación\na todas las imágenes"
            self.LCnormalize_tip = "Activar para variar el contraste a la imagen"
            self.LCbright_tip = "Aclarar u oscurecer el limite del contraste"
            self.LCaliasing_tip = "Aplicar un pequeño desenfoque.\nA veces puede dar buenos resultados"
            self.LCcrop_tip = "Seleccionar un área de recorte\nen la ventana de previsualización"
            self.LCcrop2_tip = "Hacer click y arrastrar\npara seleccionar un área de recorte"
            self.LCcrop3_tip = ""
            self.LCcrop4_tip = "Mover área de recorte"
            self.LCcrop5_tip = "Redimensionar área de recorte"
            self.LCcrop6_tip = "Eliminar área de recorte"
            self.LCreset_tip = "Deshacer rotación.\nDeja la imagen en su ángulo original"
            self.LCrot_tip = "Corregir la inclinación de la imagen"
            self.LClanguage_tip = "Escoger el idioma de reconocimiento"
            self.LCindex_tip = "Renombrar e indexar los archivos de texto resultantes"
            self.LCexec_tip = "Ejecutar el proceso de reconocimiento de carácteres. OCR\nElejir 'Todas' o 'Actual'"
            self.LCselect1_tip = "Procesar todas las imágenes"
            self.LCselect2_tip = "Procesar la imagen\nactualmente seleccionada"
            self.LCconcatnom_tip = "Nombrar el archivo de texto final\ntrás contcatenar los archivos de texto"
            self.LCconcatfiles_tip = "Seleccionar los archivos de texto a concatenar"
        elif Lang == "fr":
            self.LCtooltips = "Messages d'aide"
            self.LCselimg = "Sélection fichiers images"
            self.LCoutfolder = "Dossier de destination"

            self.LCgeneralize = "Généraliser"
            self.LCnormalize = "Contraster"
            self.LCaliasing = "Anti-bruit"
            self.LCcrop = "Couper"

            self.LCleft = "Gauche"
            self.LCright = "Droit"
            self.LCtop = "Haut"
            self.LCbottom = "Bas"

            self.LCrotate = "Rotation"
            self.LCreset = "Réinitialiser à 0º"

            self.LCocr = "ROC/OCR"
            self.LClanguage = "Langue"

            self.LCindextext = "Numérotation automatique"
            self.LCstart = "Début"
            self.LCstep = "Saut"
            self.LCcolumn = "Colonne"
            self.LCall = "Tous"
            self.LCselected = "Sélectionné"

            self.LCimage = "Fichier d'image"
            self.LCtextfile = "Fichier de texte"

            self.LCrun = "Processus"
            self.LCprocess = "Processus en cours"
            self.LCprocessend = "Reconnaissance de texte terminée!"

            self.LCprevtit = "Visualiser"
            self.LCprevtext = "Processus de pré-visualisation"

            self.LCnameoffile = "nom_du_fichier"

            self.LCabort = "Avis!"
            self.LCabort1 = "Attention!!.\nLes fichiers suivants existent déjà :\n"
            self.LCabort2 = "\nVoulez-vous vraiment écraser?"

            self.LCconcat = "Concaténer"
            self.LCseltxt = "Selectioner fichiers de texte"
            self.LCconcatnom = "Nom du fichier"
            self.LCfinaltext = "texte_définitif"

            self.LCspsanish = "Espagnol"
            self.LCenglish = "Anglais"
            self.LCdutch = "Néerlandais"
            self.LCgerman = "Allemand"
            self.LCfrench = "Français"
            self.LCitalian = "Italien"
            self.LCportuguese = "Portugais"
            self.LCrussian = "Russe"
            self.LCpolish = "Polognese"
            #--- tips french
            self.LCtooltips_tip = "Montrez ou masquer messages d'aide"
            self.LCselimg_tip = "Sélectionner des fichiers d'images à changer en texte"
            self.LCoutfolder_tip = "Sélectionner un dossier de destination"
            self.LCscrollimg_tip = "Sélectionner une image à visualiser"
            self.LCgeneralize1_tip = "Appliquer la modification du contraste\nà toutes les images ou la supprimer"
            self.LCgeneralize2_tip = "Appliquer la zone sélectionnée\nà toutes les images ou la supprimer"
            self.LCgeneralize3_tip = "Appliquer la rotation\nà toutes les images ou la supprimer"
            self.LCnormalize_tip = "Activer pour changer le contraste de l'image"
            self.LCbright_tip = "Éclaircir ou assombrir la limite de contraste"
            self.LCaliasing_tip = "Appliquer un peu de flou.\nCella vaut parfois le coup"
            self.LCcrop_tip = "Sélectionner une zone à couper\ndans la fenêtre de visualisation"
            self.LCcrop2_tip = "Cliquer-glisser pour sélectionner une zone de coupe"
            self.LCcrop3_tip = ""
            self.LCcrop4_tip = "Déplacer la zone de coupe"
            self.LCcrop5_tip = "Redimensionner la zone de coupe"
            self.LCcrop6_tip = "Supprimer la zone de coupe"
            self.LCreset_tip = "Annuler rotation.\nLaisse l'image dans son angle de vue original"
            self.LCrot_tip = "Correction de l'inclinaison de l'image"
            self.LClanguage_tip = "Choisissez la langue de reconnaissance"
            self.LCindex_tip = "Renommer et numéroter les fichiers de texte"
            self.LCexec_tip = "Exécutez le processus de reconnaissance de caractères. ROC/OCR\nChoisissez 'Tous' ou 'Sélectionné'"
            self.LCselect1_tip = "Traiter toutes les images"
            self.LCselect2_tip = "Traiter l'image sélectionné"
            self.LCconcatnom_tip = "Nommer le fichier de texte final\npuis concaténer les fichiers de texte"
            self.LCconcatfiles_tip = "Sélectionner les fichiers de texte à concaténer"
        elif Lang == "it":
            self.LCtooltips = "Messaggi di aiuto"
            self.LCselimg = "Selezionare immagini"
            self.LCoutfolder = "Cartella di destinazione"

            self.LCgeneralize = "Generalizzare"
            self.LCnormalize = "Contrasto"
            self.LCaliasing = "Antirumore"
            self.LCcrop = "Taglio"

            self.LCleft = "Sin."
            self.LCright = "Des."
            self.LCtop = "Su"
            self.LCbottom = "Giù"

            self.LCrotate = "Rotazione"
            self.LCreset = "Reimpostare 0º"

            self.LCocr = "OCR"
            self.LClanguage = "Lingua"

            self.LCindextext = "Indicizzazione automatica"
            self.LCstart = "Inizio"
            self.LCstep = "Passo"
            self.LCcolumn = "Colonna"
            self.LCall = "Tutte"
            self.LCselected = "Selezionata"

            self.LCimage = "File immagine"
            self.LCtextfile = "File testo"

            self.LCrun = "Processo"
            self.LCprocess = "Trasformazione"
            self.LCprocessend = "Riconoscimento testo completato!"

            self.LCprevtit = "Visualizzare"
            self.LCprevtext = "Processo di anteprima"

            self.LCnameoffile = "nome_del_file"

            self.LCabort = "Avviso!"
            self.LCabort1 = "Attenzione!!.\nI seguenti file esistono già:\n "
            self.LCabort2 = "\nSei sicuro di voler sovrascrivere?"

            self.LCconcat = "Concatenare"
            self.LCseltxt = "Selezionare file di testo"
            self.LCconcatnom = "Nome del file"
            self.LCfinaltext = "testo_finale"

            self.LCspsanish = "Spagnolo"
            self.LCenglish = "Inglese"
            self.LCdutch = "Olandese"
            self.LCgerman = "Tedesco"
            self.LCfrench = "Francese"
            self.LCitalian = "Italiano"
            self.LCportuguese = "Portoghese"
            self.LCrussian = "Russo"
            self.LCpolish = "Polacco"
            #--- tips italian
            self.LCtooltips_tip = "Mostrare o nascondere i messaggi di aiuto"
            self.LCselimg_tip = "Selezionare le immagini da convertire in testo"
            self.LCoutfolder_tip = "Selezionare una cartella di destinazione"
            self.LCscrollimg_tip = "Selezionare l'immagine da visualizzare"
            self.LCgeneralize1_tip = "Applicare o rimuovere il contrasto\na tutte le immagini"
            self.LCgeneralize2_tip = "Applicare o rimuovere il taglio\na tutte le immagini"
            self.LCgeneralize3_tip = "Applicare o rimuovere la rotazione\na tutte le immagini"
            self.LCnormalize_tip = "Attivare per modificare il contrasto immagine"
            self.LCbright_tip = "Schiarire o scurire il limite di contrasto"
            self.LCaliasing_tip = "Applicare una piccola sfocatura.\nA volte può dare buoni risultati"
            self.LCcrop_tip = "Selezionare un'area di ritaglio\nnella finestra di anteprima"
            self.LCcrop2_tip = "Fare clic e trascinare\nper selezionare un'area di ritaglio"
            self.LCcrop3_tip = ""
            self.LCcrop4_tip = "Spostare l'area di ritaglio"
            self.LCcrop5_tip = "Ridimensionare l'area di ritaglio"
            self.LCcrop6_tip = "Rimuovere l'area di ritaglio"
            self.LCreset_tip = "Annullare la rotazione.\nRiportare l'immagine all'angolo originale"
            self.LCrot_tip = "Correggere l'inclinazione dell'immagine"
            self.LClanguage_tip = "Scegliere la lingua di riconoscimento"
            self.LCindex_tip = "Rinominare e numerare i file di testo risultanti"
            self.LCexec_tip = "Eseguire il processo di riconoscimento dei caratteri. OCR\nScegliere 'Tutte' o 'Selezionata'"
            self.LCselect1_tip = "Trattare tutte le immagini"
            self.LCselect2_tip = "Trattare l'immagine\nattualmente selezionata"
            self.LCconcatnom_tip = "Dare un nome al file di testo finale\ndopo aver concatenato i file di testo"
            self.LCconcatfiles_tip = "Selezionare i file di testo da concatenare"

        elif Lang == "pl":
            self.LCtooltips = "Podpowiedzi"
            self.LCselimg = "Wybierz pliki obrazów"
            self.LCoutfolder = "Katalog wyjściowy"

            self.LCgeneralize = "Dla wszystkich"
            self.LCnormalize = "Kontrast"
            self.LCaliasing = "Odszumianie"
            self.LCcrop = "Przytnij"

            self.LCleft = "Lewo"
            self.LCright = "Prawo"
            self.LCtop = "Góra"
            self.LCbottom = "Dół"

            self.LCrotate = "Obróć"
            self.LCreset = "Reset 0º"

            self.LCocr = "OCR"
            self.LClanguage = "Język"

            self.LCindextext = "Automatyczne numerowanie stron"
            self.LCstart = "Start"
            self.LCstep = "Krok"
            self.LCcolumn = "Kolumny"
            self.LCall = "Wszystko"
            self.LCselected = "Zaznaczone"

            self.LCimage = "Obraz"
            self.LCtextfile = "Plik tekstowy"

            self.LCrun = "Proces"
            self.LCprocess = "Przetwarzanie"
            self.LCprocessend = "Zakończono rozpoznawanie tekstu!"

            self.LCprevtit = "Podgląd"
            self.LCprevtext = "Generowanie podglądu"

            self.LCnameoffile = "nazwa_pliku"

            self.LCabort = "Alert!"
            self.LCabort1 = "Uwaga!!.\nNastępujące pliki juz istnieją:\n "
            self.LCabort2 = "\nNa pewno nadpisać?"

            self.LCconcat = "Dołącz"
            self.LCseltxt = "Wybierz pliki"
            self.LCconcatnom = "Nazwa pliku"
            self.LCfinaltext = "final_text"

            self.LCspsanish = "Hiszpański"
            self.LCenglish = "Angielski"
            self.LCdutch = "Holenderski"
            self.LCgerman = "Niemiecki"
            self.LCfrench = "Francuski"
            self.LCrussian = "Rosyjski"
            self.LCitalian = "Włoski"
            self.LCportuguese = "Portugalski"
            self.LCpolish = "Polski"
            #--- tips english
            self.LCtooltips_tip = "Pokazuj lub ukryj podpowiedzi"
            self.LCselimg_tip = "Wybierz obrazy do przetworzenia na tekst"
            self.LCoutfolder_tip = "Wybierz katalog docelowy"
            self.LCscrollimg_tip = "Wybierz obraz do podglądu"
            self.LCgeneralize1_tip = "Zastosuj lub usuń opcje kontrastu dla wszystkich obrazów"
            self.LCgeneralize2_tip = "Zastosuj lub usuń opcje przycinania dla wszystkich obrazów"
            self.LCgeneralize3_tip = "Zastosuj lub usuń opcje obrotu dla wszystkich obrazów"
            self.LCnormalize_tip = "Aktywuj, jeśli chcesz dostosować kontrast obrazu"
            self.LCbright_tip = "Rozjaśnij lub przyciemnij kontrast"
            self.LCaliasing_tip = "Dodaj niewielkie rozmycie.\nCzasem można uzyskać dobre efekty"
            self.LCcrop_tip = "Wybierz obszar przycięcia na podglądzie obrazu"
            self.LCcrop2_tip = "Kliknij i przeciągnij aby zaznaczyć obszar przycięcia"
            self.LCcrop3_tip = ""
            self.LCcrop4_tip = "Przesuń obszar przycięcia"
            self.LCcrop5_tip = "Zmień rozmiar obszaru przycięcia"
            self.LCcrop6_tip = "Usuń obszar przycięcia"
            self.LCreset_tip = "Cofnij obracanie.\nPrzywraca oryginalne położenie obrazu"
            self.LCrot_tip = "Dostosuj kąt położenia obrazu"
            self.LClanguage_tip = "Wybierz język rozpoznawania"
            self.LCindex_tip = "Zmień nazwy i indeksuj wyjściowe pliki tekstowe"
            self.LCexec_tip = "Wykonaj rozpoznawanie tekstu\nMożesz wybrać 'Wszystko' lub 'Zaznaczone'"
            self.LCselect1_tip = "Przetwarzaj wszystkie pliki"
            self.LCselect2_tip = "Przetwórz zaznaczony plik"
            self.LCconcatnom_tip = "Nazwa końcowego pliku tekstowego\npo połączeniu różnych plików"
            self.LCconcatfiles_tip = "Wybierz pliki tekstowe do połączenia"
        # elif Lang == "nl":
        # elif Lang == "pt":
        # elif Lang == "de":
        else:
            self.LCtooltips = "Tooltips"
            self.LCselimg = "Select image files"
            self.LCoutfolder = "Output folder"

            self.LCgeneralize = "Generalize"
            self.LCnormalize = "Contrast"
            self.LCaliasing = "Denoise"
            self.LCcrop = "Crop"

            self.LCleft = "Left"
            self.LCright = "Right"
            self.LCtop = "Top"
            self.LCbottom = "Bottom"

            self.LCrotate = "Rotate"
            self.LCreset = "Reset 0º"

            self.LCocr = "OCR"
            self.LClanguage = "Language"

            self.LCindextext = "Automatic page numbering"
            self.LCstart = "Start"
            self.LCstep = "Step"
            self.LCcolumn = "Column"
            self.LCall = "All"
            self.LCselected = "Selected"

            self.LCimage = "Image"
            self.LCtextfile = "Text file"

            self.LCrun = "Process"
            self.LCprocess = "Processing"
            self.LCprocessend = "Text recogniton finished!"

            self.LCprevtit = "Previewing"
            self.LCprevtext = "Process of previewing"

            self.LCnameoffile = "name_of_file"

            self.LCabort = "Alert!"
            self.LCabort1 = "Warning!!.\nThe following files already exist:\n "
            self.LCabort2 = "\nAre you sure to overwrite them?"

            self.LCconcat = "Concatenate"
            self.LCseltxt = "Select files"
            self.LCconcatnom = "File name"
            self.LCfinaltext = "final_text"

            self.LCspsanish = "Spanish"
            self.LCenglish = "English"
            self.LCdutch = "Dutch"
            self.LCgerman = "German"
            self.LCfrench = "French"
            self.LCitalian = "Italian"
            self.LCportuguese = "Portuguese"
            self.LCrussian = "Russian"
            self.LCpolish = "Polski"
            #--- tips english
            self.LCtooltips_tip = "Show or hide tooltips"
            self.LCselimg_tip = "Selecting images to convert to text"
            self.LCoutfolder_tip = "Select a destination folder"
            self.LCscrollimg_tip = "Select an image to preview"
            self.LCgeneralize1_tip = "Aply or delete contrast option to all images"
            self.LCgeneralize2_tip = "Aply or delete crop option to all image"
            self.LCgeneralize3_tip = "Aply or delete rotation option to all image"
            self.LCnormalize_tip = "Active it if you want to vary the contrast image"
            self.LCbright_tip = "Lighten or darken the limit of contrast"
            self.LCaliasing_tip = "Aply a bit of blur.\nSometimes you can get good results"
            self.LCcrop_tip = "Select crop area in the preview image"
            self.LCcrop2_tip = "Click and drop to select crop area"
            self.LCcrop3_tip = ""
            self.LCcrop4_tip = "Move crop area"
            self.LCcrop5_tip = "Resize crop area"
            self.LCcrop6_tip = "Delete crop area"
            self.LCreset_tip = "Undo rotation.\nIt leaves the original angle of image"
            self.LCrot_tip = "Correct the angle of the image"
            self.LClanguage_tip = "Select recognition language"
            self.LCindex_tip = "Rename and index output text files"
            self.LCexec_tip = "Execute character recognition process. OCR\nYou can choice 'All' or 'Selected'"
            self.LCselect1_tip = "Process all images"
            self.LCselect2_tip = "Process selected image"
            self.LCconcatnom_tip = "Final text file name\nafter join various text files"
            self.LCconcatfiles_tip = "Select text files to join"

    def f_set_tooltips(self,data=None) :
        if self.chkTooltips.get_active() == True :

            self.btnFiles.set_tooltip_text(self.LCselimg_tip)
            self.btnDirectory.set_tooltip_text(self.LCoutfolder_tip)
            self.scrollFiles.set_tooltip_text(self.LCscrollimg_tip)

            self.edtConcat.set_tooltip_text(self.LCconcatnom_tip)
            self.btnConcat.set_tooltip_text(self.LCconcatfiles_tip)

            self.btnProcess.set_tooltip_text(self.LCexec_tip)
            self.rdAllimages.set_tooltip_text(self.LCselect1_tip)
            self.rdSelectedimages.set_tooltip_text(self.LCselect2_tip)
            self.chkPageNumbering.set_tooltip_text(self.LCindex_tip)
            self.cmbLang.set_tooltip_text(self.LClanguage_tip)
            self.lblLan.set_tooltip_text(self.LClanguage_tip)

            self.edtRotAngle.set_tooltip_text(self.LCrot_tip)
            self.btnResRot.set_tooltip_text(self.LCreset_tip)
            self.btnRot.set_tooltip_text(self.LCgeneralize3_tip)
            self.rotateDegrees.set_tooltip_text(self.LCrot_tip)

            self.frameCrop.set_tooltip_text(self.LCcrop_tip)
            self.btnCrop.set_tooltip_text(self.LCgeneralize2_tip)

            self.lblNormalize.set_tooltip_text(self.LCnormalize_tip)
            self.chkNormalize.set_tooltip_text(self.LCnormalize_tip)
            self.btnNormalize.set_tooltip_text(self.LCgeneralize1_tip)
            self.chkAliasing.set_tooltip_text(self.LCaliasing_tip)

            self.drawingArea.set_tooltip_text(self.LCcrop3_tip)

        elif self.chkTooltips.get_active() == False :

            self.btnFiles.set_tooltip_text("")
            self.btnDirectory.set_tooltip_text("")
            self.scrollFiles.set_tooltip_text("")

            self.edtConcat.set_tooltip_text("")
            self.btnConcat.set_tooltip_text("")

            self.btnProcess.set_tooltip_text("")
            self.rdAllimages.set_tooltip_text("")
            self.rdSelectedimages.set_tooltip_text("")
            self.chkPageNumbering.set_tooltip_text("")
            self.cmbLang.set_tooltip_text("")
            self.lblLan.set_tooltip_text("")

            self.edtRotAngle.set_tooltip_text("")
            self.btnResRot.set_tooltip_text("")
            self.btnRot.set_tooltip_text("")
            self.rotateDegrees.set_tooltip_text("")

            self.frameCrop.set_tooltip_text("")
            self.btnCrop.set_tooltip_text("")

            self.lblNormalize.set_tooltip_text("")
            self.chkNormalize.set_tooltip_text("")
            self.btnNormalize.set_tooltip_text("")
            self.chkAliasing.set_tooltip_text("")

            self.drawingArea.set_tooltip_text("")
    # f_frontend_lang END

    def destroy(self, widget, data=None):    # exit when main window closed
        gtk.main_quit()
    #}} destroy END

    def main(self):
        gtk.main()
    # main end
    # __init__ END
# MainWindow END 

class Dialogo(threading.Thread):
    def __init__(self,type,title,data,show,buttons=None):
        threading.Thread.__init__(self)
        self.type = type
        if buttons == True:
            if type == "files":
                self.processdialog = gtk.Dialog(title,None,gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OK,gtk.RESPONSE_OK))
            else:
                self.processdialog = gtk.Dialog(title,None,gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_OK,gtk.RESPONSE_OK))
        else:
            self.processdialog = gtk.Dialog(title,None,gtk.DIALOG_DESTROY_WITH_PARENT)
        #self.processdialog.set_size_request(340,150)
        self.processdialog.set_default_size(340,150)
        self.hboxDialog = gtk.HBox(False,5)
        self.processdialog.vbox.pack_start(self.hboxDialog,False,False,1)
        self.imgIcon=gtk.Image()
        global SHARE_PATH
        if type == "info" :
            self.processdialog.set_icon_from_file(os.path.join(SHARE_PATH, "tesseract-gui", "tesseract-gui-logo.png"))
            self.imgIcon.set_from_file(os.path.join(SHARE_PATH, "tesseract-gui", "tesseract-gui-logo.png"))
        elif type == "error" or  type == "files":
            self.processdialog.set_icon_from_file(os.path.join(SHARE_PATH, "tesseract-gui", "tesseract-gui-error.png"))
            self.imgIcon.set_from_file(os.path.join(SHARE_PATH, "tesseract-gui", "tesseract-gui-error.png"))
        self.hboxDialog.pack_start(self.imgIcon,False,False,1)
        self.lblProcessDialog = gtk.Label(data)
        self.hboxDialog.pack_start(self.lblProcessDialog , False, False, 1)
        self.lblProcessDialog.set_markup(data)
        self.processdialog.connect("response",self.destroy)
        self.processdialog.show_all()
        if show == "show":
            self.processdialog.action_area.show_now()
        elif show == "hide":
            self.processdialog.action_area.hide()
        self.processdialog.show_all()
    # create END

    def change(self,title=None,data=None):
        self.processdialog.set_title(title)
        if data :
            self.lblProcessDialog.set_markup(data)
    # change END

    def destroy(self,widget,data):
        if data == -5 or data == "ok":
            if self.type == "files" :
                my_mainwindow.f_process_continue()
            self.processdialog.destroy()
        else:
            self.processdialog.destroy()

    # destroy END
# class Dialogo END

# Funciones globales------------------------------------------------------------
def runBash(cmd):
    p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
    out = p.stdout.read().strip()
    return out
# runBash END

if __name__ == "__main__": 
    #figure out where '/usr/share' is relative to the direcotry where we are located
    SHARE_PATH = os.path.join(os.path.split(os.path.abspath(sys.argv[0]))[0], "..", "share")
    TESSDATA_PATH = "."
    for path in ("/usr/share/tessdata",
                 "/usr/local/share/tessdata",
                 os.path.join(SHARE_PATH, "tesseract-ocr", "tessdata"),os.path.join(SHARE_PATH, "tesseract", "tessdata")):
        if os.path.isdir(path):
                TESSDATA_PATH = path
                break
                
    my_mainwindow = MainWindow()
    my_mainwindow.main()

